/*
Copyright (C) 2006 Evan Teran
                   eteran@alum.rit.edu

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#ifndef DEBUGEVENT_20070116_H_
#define DEBUGEVENT_20070116_H_

#include "Types.h"

class DebugEvent {
public:
	enum REASON {
		EVENT_EXITED,	// exited normally
		EVENT_SIGNALED,	// application recieved a signal
		EVENT_STOPPED,	// we recieved an event
		EVENT_UNKNOWN
	};

	DebugEvent();
	DebugEvent(int s, edb::tid_t tid);
	DebugEvent(const DebugEvent &other);
	DebugEvent &operator=(const DebugEvent &rhs);

	int exitStatus() const;
	int exitSignal() const;
	int stopSignal() const;
	REASON reason() const;
	edb::tid_t thread() const;
	
	bool exited() const;
	bool signaled() const;
	bool stopped() const;
	
	static const int sigsegv = -1;
	static const int sigill = -2;
	static const int sigfpe = -3;
	static const int sigstop = -4;
	static const int sigtrap = -5;
	static const int sigchld = -6;
	static const int sigcont = -7;
	static const int sigkill = -8;
	static const int sigabrt = -9;
	static const int sigalrm = -10;
};

#endif

